module Asp
  class Request
    require 'cgi'
    require 'asp/common'

    public
    def form( key )
      if @oApacheRequest.request_method == "POST" 
        return @cgi.params[key]
      end
    end
  
    def queryString( key )
      if @oApacheRequest.request_method == "GET" or
         @oApacheRequest.request_method == "HEAD"
        return @cgi.params[key]
      end
    end

    def cookies( name=nil, key=nil )
      if name.nil? == true
        return @cookies
      elsif key.nil? == true and @cookies[name].nil? == false
        return @cookies[name]
      elsif String( @cookies[name].type ) == "Hash" and @cookies[name][key].nil? == false
        return @cookies[name][key]
      end

      return nil
    end

    ## -- Reserved for Ruby/ASP internal use --
    def cgi
      return @cgi
    end

    private 

#    def url_decode( value )
#        value.tr( "+", " " )
#        return value.to_s.gsub(/%[0-9a-fA-F]{2}/n){ |x| sprintf("%s", x[1..-1].hex.chr) }
#    end

    def parseCookie( value )
      values = Hash::new

      parts = value.split( /[\&\;]/ )
      parts.each { |v|
        key, value = v.split( /\=/, 2 ).map { |x|
          Asp::Common::url_decode( x )
        }
        values[key] = value
      }

      return values
    end

    def getCookies
      cookiesStr = @oApacheRequest.headers_in['Cookie']
      cookies = Hash::new

      if cookiesStr.nil? == false
        parts = cookiesStr.split( /;\s*/ )
        parts.each { |v|
          name, value = v.split( /\=/, 2 )
          name = Asp::Common::url_decode( name )
          #next if name == "session-id"
          next if name == Asp::Common::sessionID
          next if cookies[name].nil? == false
          if /\=/ =~ value
            cookies[name] = parseCookie( value )
          else
            cookies[name] = Asp::Common::url_decode( value )
          end
        }
      end

      return cookies
    end
    
    def initialize( r )
      @oApacheRequest = r
      @cgi = CGI::new( )
      @cookies = getCookies
    end
  
  end
end
