module Asp
  class Response
    require 'asp/common'
    
    attr_accessor :charset,:contentType,:expires,:expiresAbsolute
  
    public
    
    def write( data )
      print data
    end
    
    def addHeader( name, value )
      @hxHeader.store( name, value )
    end
  
    def appendToLog( message )
      @oApacheRequest.server.log_error( "[Ruby/ASP] [%d] %s", $$, message )
    end
  
    def end
      @bEnd = 1
    end
  
    def include( filename, *args )
      secure = filename.taint
      $SAFE=1
      secure.untaint
      if File.exist?( filename ) == true
        load( filename )
        return true
      else
        @oApacheServer.log_error( "[Ruby/ASP] [%d] Error loading '%s' !", $$, filename )
        return false
      end
    end

	def trapInclude( filename, *args )
	end
  
    def redirect( url )
      self.addHeader( "location", url )
      @oApacheRequest.status = 302
    end
    
    #
    # $Response.cookies('name', 'value');
    # --> Set-Cookie: name=value; path=/
    # 
    # $Response.cookies("Test", "data1", "test value");
    # $Response.cookies("Test", "data2", "more test");      
    # $Response.cookies("Test", "Expires", &HTTP::Date::time2str(time+86400)); 
    # $Response.cookies("Test", "Secure", 1);               
    # $Response.cookies("Test", "Path", "/");
    # $Response.cookies("Test", "Domain", "host.com");
    # --> Set-Cookie:Test=data1=test%20value&data2=more%20test;    \
    #            expires=Fri, 23 Apr 1999 07:19:52 GMT;        \
    #            path=/; domain=host.com; secure
    def cookies( name, key, value=nil )
      if @hvCookies[name].nil? == true
        @hvCookies[name] = Hash::new
      end
      
      if value.nil? == false 
        @hvCookies[name][key] = String( value )
      else
        # we are assigning cookie with name the value of key
        @hvCookies[name]['Value'] = String( key )
      end 
    end

    ## -- Reserved for Ruby/ASP internal use --
    def getHeader
      xTime = nil
      if @expires != nil
        xTime = Asp::Common::time2str( Time::now + @expires )
      elsif @expiresAbsolute != nil
        xTime = Asp::Common::str2time( @expiresAbsolute )
      end
      if xTime != nil
        @hxHeader.store( "Expires", xTime )
      end
      return @hxHeader
    end
    
    def addCookiesHeader
      cookie_header = Array::new
      
      @hvCookies.each_key { |name| 
        value = Array::new
  
        #if name == "session-id"
        if name == Asp::Common::sessionID
          self.appendToLog( format( "You can't use %s for a cookie name since it is reserved for session management", Asp::Common::sessionID ) )
        else
          cookie = @hvCookies[name]
          cookie['Path'] ||= "/"
  
          cookie.each_pair { |k,v|
            case k.downcase
            when "expires"
              value[1] = "expires=#{v}"
            when "path"
              value[2] = "path=#{v}"
            when "domain"
              value[3] = "domain=#{v}"
            when "secure"
              value[4] = "secure"
            when "value"
              # we set the value later, nothing for now
            else
              if String( @hvCookies[name]['Value'].type ) != "String"
                if @hvCookies[name]['Value'].nil? == true
                  @hvCookies[name]['Value'] = Hash::new
                end
                @hvCookies[name]['Value'][k] = v
              end
            end
          }
 
          if String( @hvCookies[name]['Value'].type ) == "Hash"
            dict = Array::new
            @hvCookies[name]['Value'].each_pair { |k,v|
              dict.push( format( "%s=%s", Asp::Common::url_encode( k ), Asp::Common::url_encode( v ) ) )
            }
            value[0] = dict.join( "&" )
          else
            value[0] = Asp::Common::url_encode( @hvCookies[name]['Value'] )
          end
          value[0] = Asp::Common::url_encode( name )+"="+value[0]
          
          cookie = Array::new
          [0,1,2,3,4].each { |iCpt|
            next unless value[iCpt].nil? == false
            cookie.push( value[iCpt] )
          }
    
          cookie_header.push( cookie.join( "; " ) )
        end
      }

      return( cookie_header )
    end

    private 
    
#    def time2str( time )
#      return time.strftime( "%a, %d %b %Y %H:%M:%S GMT" ) # Wed, 09 Feb 1994 22:23:32 GMT
#    end
#  
#    def str2time( time )
#      return time ## TODO !!!
#    end
#
#    def url_encode( s )
#      return s.to_s.gsub(/[^a-zA-Z0-9_\-.]/n){ sprintf("%%%02X", $&.unpack("C")[0]) }
#    end
#
#    def html_escape( s )
#      return s.to_s.gsub(/&/, "&amp;").gsub(/\"/, "&quot;").gsub(/>/, "&gt;").gsub(/</, "&lt;")
#    end
    
    def initialize( r )
      @charset = "iso-8859-1"
      @contentType = "text/html"
      @expires = nil
      @expiresAbsolute = nil
      @oApacheRequest = r
      @bEnd = 0
      @hxHeader = Hash::new
      @hvCookies = Hash::new
    end
  
  end
end
